<?xml version="1.0" encoding="UTF-8"?>

<cfsSimulation xmlns="http://www.cfs++.org/simulation">
 
 
  <documentation>
    <title>Two Scale Optimization of the mechanic coefficient.</title>
    <authors>
      <author>Fabian Wein</author>
    </authors>
    <date>2015-04-22</date>
    <keywords>
      <keyword>SIMP</keyword>
    </keywords>
    <references>FMO</references>
    <isVerified>no</isVerified>
    <description>Similar to FMO but only diagonal coefficients are optimized, therefore no defnitieness constraints are necessary.
    Static case with compliance minimization.</description>
  </documentation>

  <fileFormats>
    <output>
      <hdf5/>
      <info/>
    </output>
    <materialData file="mat.xml" format="xml" />
  </fileFormats>

  <domain geometryType="plane">
    <regionList>
      <!-- dummy material as we have material parameterization -->
      <region material="99lines" name="mech" />
    </regionList>
  </domain>

  <sequenceStep index="1">
    <analysis>
      <static/>
    </analysis>

    <pdeList>
      <mechanic subType="planeStrain">
        <regionList>
          <region name="mech" />
        </regionList>

        <bcsAndLoads>
           <fix name="west"> 
              <comp dof="x"/> <comp dof="y"/> 
           </fix>
          <force name="right_lower">
              <comp dof="y" value="-1"/>
          </force>
        </bcsAndLoads>
        <storeResults>
          <nodeResult type="mechDisplacement">
            <allRegions />
          </nodeResult>
          <elemResult type="mechTensor">
            <allRegions/>
          </elemResult>
          <elemResult type="mechTensorHillMandel">
            <allRegions/>
          </elemResult>
       </storeResults>
      </mechanic>
    </pdeList>
  </sequenceStep>

  <optimization>
    <costFunction type="compliance" task="minimize">
      <stopping queue="999" value="0.002" type="designChange" />
    </costFunction>

   <constraint type="volume" bound="upperBound" value="0.5" design="mech_trace" linear="true" notation="hill_mandel"/>
   <constraint type="tensorTrace" bound="upperBound" value="1.0" design="mech_trace" linear="true" notation="hill_mandel"/>

    <optimizer type="snopt" maxIterations="10">
      <snopt>
        <option name="verify_level" type="integer" value="0"/>
      </snopt>
    </optimizer>

    <ersatzMaterial region="mech" material="mechanic" method="paramMat">
      <paramMat>
        <designMaterials>
          <designMaterial type="fmo">
            <param name="mech_12" value="0.0"/>
            <param name="mech_13" value="0.0"/>
            <param name="mech_23" value="0.0"/>
          </designMaterial>
        </designMaterials>   
      </paramMat>
      <design name="mech_11" initial="0.33" lower="0.1" upper="1.0"/>
      <design name="mech_22" initial="0.33" lower="0.1" upper="1.0"/>
      <design name="mech_33" initial="0.33" lower="0.1" upper="1.0"/>
      <export save="last" />
    </ersatzMaterial>
    <commit mode="each_forward" stride="1" />
  </optimization>
 
  
</cfsSimulation>


